import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;

public class decomp {
	public static void main(String[] args) {
		try (Scanner scanner = new Scanner(new File("decomp.in"));
				BufferedOutputStream output = new BufferedOutputStream(
						new FileOutputStream(new File("decomp.out")))) {

			int n = scanner.nextInt();
			int[] a = new int[n];
			int[] b = new int[n];

			for (int i = 0; i < n; i++) {
				b[i] = -1;
				a[i] = scanner.nextInt();
			}

			int count = 0;
			ArrayList<Integer> used = new ArrayList<>();

			for (int i = 0; i < n; i++) {
				int t = i + a[i];

				if (b[t % n] != i && b[t % n] != -1) {
					output.write("-1\n".getBytes());
					return;
				}

				b[t % n] = i;
			}

			flag: for (int i = 0; i < n; i++) {
				int tmp = i;

				do {
					if (used.contains(tmp))
						continue flag;

					used.add(tmp);
					tmp += a[tmp % n];
				} while (tmp % n != i);

				count++;
			}

			output.write((count + "\n").getBytes());

		} catch (IOException ignored) {
		}
	}
}