import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Scanner;

public class divisors {

	public static void main(String[] args) {		
		BigInteger[] divs = { BigInteger.valueOf(2), BigInteger.valueOf(3),
				BigInteger.valueOf(5), BigInteger.valueOf(7) };
		long[] counts = new long[4];

		try (Scanner scanner = new Scanner(new File("divisors.in"));
				BufferedOutputStream output = new BufferedOutputStream(
						new FileOutputStream(new File("divisors.out")))) {

			BigInteger n = new BigInteger(scanner.next());

			long count = 1;

			for (int i = 0; i < 4; i++) {
				BigInteger tmp = n;

				while (tmp.mod(divs[i]) == BigInteger.ZERO) {
					counts[i]++;
					count++;
					tmp = tmp.divide(divs[i]);
				}
			}
			
			if (count != counts[0] + 1 && count != counts[1] + 1 && count != counts[2] + 1 && count != counts[3] + 1)
				count += (counts[0] == 0 ? 1 : counts[0]) * (
						counts[1] == 0 ? 1 : counts[1]) * 
						(counts[2] == 0 ? 1 : counts[2]) * 
						(counts[3] == 0 ? 1 : counts[3]);

			output.write((count + "\n").getBytes());

		} catch (IOException ignored) {
		}
	}
}
