""" Python 3 """

fin = open('decomp.in')
fout = open('decomp.out', 'w')

n = int(fin.readline())
seq = [int(i) for i in fin.readline().split(' ')]
inTrack = [0 for i in range(n)]
paths = 0

def track(index):
    start = index
    repeats = 0
    inTrack[index] = 1
    index += seq[index]
    if index >= n:
        repeats += index//n
    index %= n
    while index != start:
        if not inTrack[index]:
            inTrack[index] = 1
        else:
            return None
        index += seq[index]
        if index >= n:
            repeats += index//n
        index %= n
    return repeats

for i in range(n):
    if not inTrack[i]:
        t = track(i)
        if t is None:
            paths = -1
            break
        else:
            paths += t

fout.write(str(paths) + '\n')

fin.close()
fout.close()

