/* GCC */
#include<iostream>
#include<vector>
#include<iomanip>
#include<fstream>

using namespace std;

typedef unsigned long long ull;

void searching(int days, int& number, int day_now, ull price_now, ull& price_max, ull& price_min, int cave, const vector<vector<ull> >& counts, const vector<ull> prices, const vector<vector<int> >& cav)
{
    price_now+=counts[day_now][cave];
    if (day_now < days){
        for (int i = 0; i < cav[cave].size(); ++i){
            searching(days, number, day_now+1, price_now, price_max, price_min, cav[cave][i], counts, prices, cav);
            //cout << cav[cave][i] << " ";
        }
    }
    else{
        bool no = true;
        for (int i = 0; i < prices.size(); ++i){
            if (prices[i] == price_now) no = false;
        }
        if (no){
            ++number;
            if (price_now > price_max) price_max = price_now;
            if (price_now < price_min) price_min = price_now;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    ifstream cin("caves.in");
    ofstream cout("caves.out");
    int m, l;
    cin >> m >> l;

    vector<vector<int> > cav(11);
    for (int i = 0; i < 10; ++i){
        for (int j = 0; j < 10; ++j){
            int x;
            cin >> x;
            if (x == 1) cav[i+1].push_back(j+1);
        }
    }

    /*for (int i = 0; i < 11; ++i){
        for (int j = 0; j < cav[i].size(); ++j){
            cout << cav[i][j] << " ";
        }
        cout << '\n';
    }*/

    vector<vector<ull> > counts(m+1, vector<ull> (11));
    for (int i = 1; i < m+1; ++i){
        for (int j = 1; j < 11; ++j){
            cin >> counts[i][j];
        }
    }

    vector<ull> prices(l);
    for (int i = 0; i < l; ++i){
        cin >> prices[i];
    }

    int number = 0;
    ull price_max = 0;
    ull price_min = 1e18;
    //cout << price_min << '\n';

    for (int i = 1; i < 11; ++i){
        searching(m, number, 1, 0, price_max, price_min, i, counts, prices, cav);
    }

    if (number == 0) price_min = 0;

    cout << number << " " << price_max << " " << price_min << '\n';
}
/*
2 6
1 0 1 0 0 0 0 0 0 0
0 1 0 0 0 0 0 0 0 0
1 0 1 0 0 0 0 0 0 0
0 0 0 1 0 0 0 0 0 0
0 0 0 0 1 0 0 0 0 0
0 0 0 0 0 1 0 0 0 0
0 0 0 0 0 0 1 0 0 0
0 0 0 0 0 0 0 1 0 0
0 0 0 0 0 0 0 0 1 0
0 0 0 0 0 0 0 0 0 1
1 2 3 0 0 0 0 0 0 0
4 5 6 0 0 0 0 0 0 0
7 0
WHAT THE HELL?! I WROTE THIS ONE FOR NOTHING?!!
*/
