/* GCC */
#include <iostream>
#include <fstream>

using namespace std;

const int MAX=1e6+1;

int n, ans, mx;
bool can=true;
bool vis[MAX];
int arr[MAX];

int main()
{
    ifstream cin("decomp.in");
    ofstream cout("decomp.out");
    ios::sync_with_stdio(0);
    cin >> n;
    for(int i=0; i<n; ++i)
        cin >> arr[i], mx=max(arr[i], mx);
    int cnt=(mx/n)+(mx%n!=0);
    for(int i=1; i<cnt; ++i)
        for(int j=0; j<n; ++j)
            arr[j+n*i]=arr[j];
    for(int i=0; i<n*cnt&&can; ++i)
    {
        int now=i;
        if(!vis[now])
        {
            do
            {
                vis[now]=true;
                int next=(now+arr[now])%(cnt*n);
                if(next<=now) ++ans;
                if(vis[next]&&next!=i) can=false;
                now=next;
            }
            while(now!=i&&can);
        }
    }
    if(can) cout << ans << endl;
    else cout << "-1\n";
    return 0;
}
