/* GCC */
#include <iostream>
#include <fstream>
#include <queue>

using namespace std;

int main()
{
    ifstream in;
    ofstream out;
    in.open("caves.in");
    out.open("caves.out");
    int m = 0, l = 0;
    in >> m >> l;
    const int n = 10;
    int cave_map[n][n];
    for (int x = 0; x < n; x++) {
        for (int y = 0; y < n; y++) {
            in >> cave_map[x][y];
        }
    }
    int awards[n][m];
    for (int i = 0; i < m; i++) {
        for (int k = 0; k < n; k++) {
            in >> awards[k][i];
        }
    }
    unsigned long long king_nums[l];
    for (int i = 0; i < l; i++) {
        in >> king_nums[i];
    }
    int paths = 0;
    unsigned long long max_award = 0, min_award = 1; min_award <<= 63;
    for (int i = 0; i < n; i++) {
        if (awards[i][0] == 0) continue;
        queue <int> caves;
        queue <unsigned long long> cur_award;
        queue <int> days;
        caves.push(i);
        cur_award.push(awards[i][0]);
        days.push(0);
        while (!caves.empty()) {
            cout << caves.front() << " " << days.front() << " " << cur_award.front() << endl;
            if (days.front() == m-1) {
                min_award = min (min_award, cur_award.front());
                max_award = max (max_award, cur_award.front());
                paths++;
                bool kn = false;
                for (int j = 0; j < l; j++) {
                    if (cur_award.front() == king_nums[j]) {
                        caves.pop(); days.pop(); cur_award.pop();
                        kn = true;
                        break;
                    }
                    if (cur_award.front() > king_nums[j]) {
                        break;
                    }
                }
                if (!kn) {
                    paths++;
                    cout << "+" << endl;
                }
                caves.pop(); days.pop(); cur_award.pop();
                continue;
            }
            for (int i = 0; i < n; i++) {
                if (cave_map[caves.front()][i] == 1) {
                    bool kn = false;
                    for (int j = 0; j < l; j++) {
                        if (cur_award.front() + awards[caves.front()][days.front()] == king_nums[j]) {
                            caves.pop(); days.pop(); cur_award.pop();
                            kn = true;
                            break;
                        }
                        if (cur_award.front() + awards[caves.front()][days.front()] > king_nums[j]) {
                            break;
                        }
                    }
                    if (!kn) {
                        caves.push(i);
                        days.push(days.front()+1);
                        cur_award.push(cur_award.front() + awards[i][days.front()+1]);
                    }
                }
            }
            caves.pop(); days.pop(); cur_award.pop();
        }
    }
    if (paths == 0) {
        out << "0 0 0" << endl;
    }
    else out << paths << " " << max_award << " " << min_award << endl;
    in.close();
    out.close();
    return 0;
}
