/* GCC */
#include <iostream>
#include <fstream>

using namespace std;

int main()
{
    ifstream in;
    ofstream out;
    in.open("decomp.in");
    out.open("decomp.out");
    int n = 0;
    in >> n;
    int a[n];
    for (int i = 0; i < n; i++) {
        in >> a[i];
    }
    int visit[n];
    for (int i = 0; i < n; i++) {
        visit[i] = 0;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (visit[i] == 0) {
            int j = i;
            visit[j] = -1; //start cell
            do {
                j += a[j];
                if (j >= n) {
                    ans ++;
                    j %= n;
                }
                if (visit[j] == 1) {
                    out << "-1" << endl;
                    return 0;
                }
                else if (visit[j] == -1) {
                    visit[j] = 1;
                    break;
                }
                else visit[j] = 1;
            } while (true);
        }
    }
    out << ans << endl;
    in.close();
    out.close();
    return 0;
}
