/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <utility>
#include <algorithm>

using namespace std;

ifstream in("divisors.in");
ofstream out("divisors.out");

int ans=1;
vector<int>prost;
map<long long,bool>used;
long long n;

void quickSort(int left,int right)
{
    int i=left,j=right;
    long long mid=used[(i+j)/2];
    while(i<=j)
    {
        while(mid<used[j])
            --j;
        while(mid>used[i])
            ++i;
        if(i<=j)
        {
            swap(i,j);
            ++i;
            --j;
        }
    }
    if(left<j)
        quickSort(left,j);
    if(i<right)
        quickSort(i,right);
}

void check(int maxDeep,int currDeep=1,int pos=0,long long sum=1)
{
    for(int i=pos;i<prost.size();++i)
    {
        if(currDeep!=maxDeep) check(maxDeep,currDeep+1,i+1,sum*prost[i]);
//        if(!binary_search(used.begin(),used.end(),sum*prost[i]))
        if(!used[sum*prost[i]])
        {
//            out<<sum*prost[i]<<" ";
//            used.push_back(sum*prost[i]);
//            sort(0,used.size()-1);
            used[sum*prost[i]]=true;
 //           out<<sum*prost[i]<<" ";
            ++ans;
        }
    }
}

int main()
{
    in>>n;
    for(int i=2;i<=7;++i)
    {
        while(n%i==0)
        {
            prost.push_back(i);
            n/=i;
        }
    }
    check(prost.size());
    out<<ans<<endl;
    in.close();
    out.close();
    return 0;
}
