/* GCC */
#include <iostream>
#include <fstream>

using namespace std;
int a[100000], ans(0);
bool used[100000] = {};

int main(void)
{
    ios_base::sync_with_stdio(false);
    ifstream in("decomp.in");
    int n;
    in >> n;
    for(int i = 0; i < n; ++i)
        in >> a[i];
    in.close();
    bool bad = false;
    for(int i = 0; i < n && !bad; ++i)
        if(!used[i])
            for(int j = i, period = 0; ; )
            {
                if(used[j])
                {
                    if(j == i)
                        ans += period;
                    else
                        bad = true;
                    break;
                }
                used[j] = true;
                j += a[j];
                period += j / n;
                j %= n;
            }
    ofstream out("decomp.out");
    if(bad)
        out << "-1\n";
    else
        out << ans << '\n';
    out.close();
    return 0;
}
