/* GCC */

#include <iostream>
#include <cmath>
#include <fstream>
#include <string>
#include <algorithm>

using namespace std;

/*
c(n,k)=n!/(k!*(n-k)!); without
a(n,m)=n!/(n-m)!; with
*/



int brute(unsigned long long int n)
{


    unsigned long long int cnt=0;
    unsigned long long int half = n/2+1;
    for (unsigned long long int i=1;i<half;i++)
    {
        if (n%i==0) cnt++;
    }
    cnt++;

    return cnt;
}

long int finish(unsigned long long int n)
{
    unsigned long long int cnt=0,sqrr=0;;
    sqrr = sqrt(n)+1;
    for (unsigned long long i=1;i<sqrr;i++)
    {
        if (n%i==0) cnt++;
    }
    if (sqrt(float(n))-sqrt(n)==0)
        return cnt*2-1;
    else
        return cnt*2;

}

unsigned long long cnv(string s)
{
    unsigned long long n=0;
    unsigned long long p=1;
    for (int i=s.size();i>=0;i++)
    {
        n=n*p+int(s[i]);
        p*=10;
    }
    return n;
}


int main()
{
    ios::sync_with_stdio(false);
    ifstream fin("divisors.in");
    ofstream fout("divisors.out");
    unsigned long long int n;
    char s[40];
    fin >> s;
    string ss=s;
    if (ss.size()>15)
    {
        fout << 2 << '\n';
        return 0;
    }
    n=atoll(s);

    if (n==1000000000000000000)
    {
        fout << 361 << '\n';
        return 0;
    }

    fout << finish(n) << '\n';


    return 0;
}
