/* GCC */

#include <iostream>
#include <fstream>
using namespace std;

int number[32];
int n = 0;
int div2 = 0, div3 = 0, div5 = 0, div7 = 0;

void divide(int divider)
{
    int temp;
    for (int i = 0; i < n; i++)
    {
        temp = number[i] % divider;
        number[i + 1] += temp*10;
        number[i] /= divider;
    }
}

int sum()
{
    int s = 0;
    for (int i = 0; i < n; i++)
        s += number[i];
    return s;
}

bool check7()
{
    if (n == 1 && number[0] == 1)
        return false;
    if (number[n - 1] != 1)
        return true;
    bool f = false;
    for (int i = 0; i < n - 1; i++)
        if (number[i] != 0)
        {
            f = true;
            break;
        }
    if (f)
        return true;
    return false;
}

int main()
{
    ifstream in;
    in.open("divisors.in", ios_base::in);
    ofstream out;
    out.open("divisors.out", ios_base::out);

    char c;
    while (in >> c)
    {
        number[n] = c - '0';
        n++;
    }

    while (number[n - 1] % 2 == 0)
    {
        divide(2);
        div2++;
    }

    while (sum() % 3 == 0)
    {
        divide(3);
        div3++;
    }

    while (number[n - 1] % 5 == 0)
    {
        divide(5);
        div5++;
    }

    while (check7())
    {
        divide(7);
        div7++;
    }

    out << (div2 + 1)*(div3 + 1)*(div5 + 1)*(div7 + 1) << endl;

    return 0;
}
